#include "constants.h"

#pragma OPENCL EXTENSION cl_khr_fp64: enable           //FIXED
__kernel void ComputeResidual(__global const REAL* restrict x, 
                              __global const REAL* restrict dx_dt,
                              __global REAL* restrict F)
{

    int i = get_global_id(0);
    int j = get_global_id(1);

    if (i<N1-1 && j<N2-1) {
        F[INDEX_GLOBAL(i,j)] = dx_dt[INDEX_GLOBAL(i,j)] -
                               (x[INDEX_GLOBAL(i+1,j)] - 
                                x[INDEX_GLOBAL(i,j)])/DX1 -
                               (x[INDEX_GLOBAL(i,j+1)] - 
                                x[INDEX_GLOBAL(i,j)])/DX2;
    }
}

